﻿Imports Microsoft.Win32.SafeHandles
Imports System.Text
Imports System.Diagnostics.FileVersionInfo
Imports System.Runtime.InteropServices

Module Module1

    Public Const INVALID_HANDLE_VALUE = -1

    '   Windows APIの定義
    Public Declare Function Wow64DisableWow64FsRedirection Lib "kernel32" (ByRef oldvalue As Long) As Boolean
    Public Declare Function Wow64RevertWow64FsRedirection Lib "kernel32" (ByVal oldvalue As Long) As Boolean
    Public Declare Function timeGetTime Lib "winmm.dll" () As Long

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GetLastError() As Integer
    end function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalAlloc(ByVal uFlags As Integer, ByVal dwBytes As Integer) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalFree(ByVal handle As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalLock(ByVal handle As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalUnlock(ByVal handle As IntPtr) As Boolean
    End Function

    <DllImport("kernel32.dll", SetLastError:=True, CharSet:=CharSet.Unicode)>
    Public Function CreateFile(ByVal lpFileName As String, ByVal dwDesiredAccess As System.UInt32, ByVal dwShareMode As System.UInt32, ByVal lpSecurityAttributes As IntPtr, ByVal dwCreationDisposition As System.UInt32, ByVal dwFlagsAndAttributes As System.UInt32, ByVal hTemplateFile As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True, ExactSpelling:=True)>
    Public Function CloseHandle(ByVal hObject As IntPtr) As Integer
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True, ExactSpelling:=True)>
    Public Function WriteFile(ByVal hFile As Long, ByRef lpBuffer As Long, ByVal nNumberOfBytesToWrite As Integer, ByRef lpNumberOfBytesWritten As Integer, ByRef lpOverlapped As Integer) As Boolean
    End Function

    Public Const GMEM_FIXED = &H0
    Public Const GMEM_ZEROINIT = &H40
    Public Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)
    Public Const FILE_ATTRIBUTE_NORMAL As Short = &H80
    Public Const GENERIC_READ As Long = &H80000000
    Public Const GENERIC_WRITE As UInteger = &H40000000
    Public Const CREATE_NEW As UInteger = 1
    Public Const CREATE_ALWAYS As UInteger = 2
    Public Const OPEN_EXISTING As UInteger = 3

    Public FoundDeviceHandle(USB_MAX_DEVICE) As IntPtr
    Public OpenDeviceHandle(USB_MAX_DEVICE) As IntPtr
    Public OpenNum As Integer

    Public BoardSel(16) As Button
    Public BoardName(256) As String
    Public BoardIndex(256) As Integer
    Public SelFormStart As Boolean = False

    '   WinUSB関連
    <DllImport("user32.dll", CharSet:=CharSet.Auto, SetLastError:=True)>
    Public Function RegisterDeviceNotification(ByVal hRecipient As IntPtr, ByVal NotificationFilter As IntPtr, ByVal Flags As Integer) As IntPtr
    End Function

    <StructLayout(LayoutKind.Sequential)>
    Public Class DEV_BROADCAST_DEVICEINTERFACE
        Friend dbcc_size As Integer
        Friend dbcc_devicetype As Integer
        Friend dbcc_reserved As Integer
        Friend dbcc_classguid As Guid
        Friend dbcc_name As Short
    End Class

    <StructLayout(LayoutKind.Sequential)>
    Friend Class DEV_BROADCAST_HDR
        Friend dbch_size As Integer
        Friend dbch_devicetype As Integer
        Friend dbch_reserved As Integer
    End Class

    Public Const DBT_DEVTYP_DEVICEINTERFACE As Integer = 5
    Public Const DEVICE_NOTIFY_WINDOW_HANDLE As Integer = 0
    Public Const DBT_DEVICEREMOVECOMPLETE As Integer = &H8004
    Public Const DBT_DEVICEARRIVAL As Integer = &H8000

    '   --------------------------------------------------------------------------------
    '   ﾛｸﾞ用関数
    Public Sub LOG_PRINT(ByVal msg As String)

        Dim Now As DateTime = DateTime.Now
        LOGForm.RichTextBox1.AppendText("【" & Now & "】 " & msg & vbCrLf)

    End Sub

    '   --------------------------------------------------------------------------------
    '   WinUSBﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝの取得
    Public Sub GetVer()

        Dim VerInfo As FileVersionInfo
        Dim handle As IntPtr

        '   ﾄﾞﾗｲﾊﾞﾍのﾘﾀﾞｲﾚｸﾄを禁止
        Wow64DisableWow64FsRedirection(handle)

        Try
            VerInfo = FileVersionInfo.GetVersionInfo(Environment.SystemDirectory + "\drivers\winusb.sys")
        Catch ex As Exception

            MsgBox("ﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝの取得に失敗しました。")
            Exit Sub

        End Try

        LOG_PRINT("winusb.sys = Ver" & VerInfo.FileVersion.ToString)

    End Sub

    '   --------------------------------------------------------------------------------
    '   各種ｺﾝﾎﾟｰﾈﾝﾄの切り替え
    Public Sub Component_Change(ByVal sel As Boolean)

        '   ﾚｼﾞｽﾀ操作TAB
        MainForm.NumericUpDown1.Enabled = sel
        MainForm.NumericUpDown2.Enabled = sel
        MainForm.NumericUpDown3.Enabled = sel
        MainForm.ComboBox1.Enabled = sel
        MainForm.ComboBox2.Enabled = sel
        MainForm.ComboBox3.Enabled = sel
        MainForm.TextBox1.Enabled = sel
        MainForm.TextBox2.Enabled = sel
        MainForm.TextBox3.Enabled = sel
        MainForm.MaskedTextBox1.Enabled = sel
        MainForm.MaskedTextBox2.Enabled = sel
        MainForm.MaskedTextBox3.Enabled = sel
        MainForm.Button3.Enabled = sel
        MainForm.Button4.Enabled = sel
        MainForm.Button5.Enabled = sel
        MainForm.Button6.Enabled = sel
        MainForm.Button7.Enabled = sel
        MainForm.Button8.Enabled = sel

        '   ﾒﾓﾘ操作TAB
        MainForm.TextBox4.Enabled = sel
        MainForm.TextBox5.Enabled = sel
        MainForm.TextBox6.Enabled = sel
        MainForm.TextBox7.Enabled = sel
        MainForm.ComboBox4.Enabled = sel
        MainForm.ComboBox5.Enabled = sel
        MainForm.Button9.Enabled = sel
        MainForm.Button10.Enabled = sel
        MainForm.Button11.Enabled = sel
        MainForm.Button12.Enabled = sel
        MainForm.Button13.Enabled = sel
        MainForm.Button14.Enabled = sel

        '   USBｺﾝﾌｨｸﾞTAB
        MainForm.TextBox8.Enabled = sel
        MainForm.CheckBox1.Enabled = sel
        MainForm.CheckBox2.Enabled = sel
        MainForm.CheckBox3.Enabled = sel
        MainForm.Button15.Enabled = sel
        MainForm.Button16.Enabled = sel

        '   ﾎﾞｰﾄﾞ情報TAB
        MainForm.Button18.Enabled = sel

        '   ﾒｲﾝﾒﾆｭｰ
        MainForm.WordToolStripMenuItem1.Enabled = sel
        MainForm.BurstToolStripMenuItem1.Enabled = sel
        MainForm.WordToolStripMenuItem.Enabled = sel
        MainForm.BurstToolStripMenuItem.Enabled = sel
        MainForm.ﾒﾓﾘ転送ﾓｰﾄﾞ切換えToolStripMenuItem.Enabled = sel

    End Sub

    '   --------------------------------------------------------------------------------
    '   ﾚｼﾞｽﾀﾘｰﾄﾞ処理
    Public Function gui_Reg_Read(ByVal hHandle As Integer, ByVal Adrs As UInteger, ByVal Width As UInteger, ByRef Rd As String) As Boolean

        Dim reg As ULong
        Dim range As UInteger

        '   有効なﾊﾝﾄﾞﾙが指定されているか?
        If (hHandle = INVALID_HANDLE_VALUE) Then
            Return False
        End If

        '   ﾚｼﾞｽﾀﾚﾝｸﾞｽの処理
        Select Case Width

            Case 0  '   8bit
                range = SUP64_RANGE_8BIT

            Case 1  '   16bit
                range = SUP64_RANGE_16BIT

            Case 2  '   32bit
                range = SUP64_RANGE_32BIT

            Case 3  '   64bit
                range = SUP64_RANGE_64BIT

            Case Else   '   8bit
                range = SUP64_RANGE_8BIT

        End Select

        '   ﾚｼﾞｽﾀﾘｰﾄﾞ処理(DLL関数ｺｰﾙ)
        If (SUP64_Reg_Read(hHandle, Adrs, range, reg) = False) Then
            Return False
        End If

        '   桁整理して表示する
        Select Case Width

            Case 0  '   8bit
                reg = reg And &HFFUL
                Rd = reg.ToString("X2")

            Case 1  '   16bit
                reg = reg And &HFFFFUL
                Rd = reg.ToString("X4")

            Case 2  '   32bit
                reg = reg And &HFFFFFFFFUL
                Rd = reg.ToString("X8")

            Case 3  '   64bit
                reg = reg And &HFFFFFFFFFFFFFFFFUL
                Rd = reg.ToString("X16")

            Case Else
                reg = reg And &HFF
                Rd = reg.ToString("X2")

        End Select

        Return True

    End Function

    '   --------------------------------------------------------------------------------
    '   ﾚｼﾞｽﾀﾗｲﾄ処理
    Public Function gui_Reg_Write(ByVal hHandle As Integer, ByVal Adrs As UInteger, ByVal Width As UInteger, ByRef WdText As String) As Boolean

        Dim reg As ULong
        Dim range As UInteger

        '   有効なﾊﾝﾄﾞﾙが指定されているか?
        If (hHandle = INVALID_HANDLE_VALUE) Then
            Return False
        End If

        '   ﾚｼﾞｽﾀﾚﾝｸﾞｽの処理
        Select Case Width

            Case 0  '   8bit
                range = SUP64_RANGE_8BIT

            Case 1  '   16bit
                range = SUP64_RANGE_16BIT

            Case 2  '   32bit
                range = SUP64_RANGE_32BIT

            Case 3  '   64bit
                range = SUP64_RANGE_64BIT

            Case Else   '   8bit
                range = SUP64_RANGE_8BIT

        End Select

        '   ﾗｲﾄﾃﾞｰﾀ取得
        Try
            reg = ULong.Parse(WdText, Globalization.NumberStyles.HexNumber)
        Catch ex As Exception
            Return False
        End Try

        '   ﾚｼﾞｽﾀﾗｲﾄ処理(DLL関数ｺｰﾙ)
        If (SUP64_Reg_Write(hHandle, Adrs, range, reg) = False) Then
            Return False
        End If

        '   ﾗｲﾄﾃﾞｰﾀを大文字に変換
        Select Case Width

            Case 0  '   8bit
                WdText = reg.ToString("X2")

            Case 1  '   16bit
                WdText = reg.ToString("X4")

            Case 2  '   32bit
                WdText = reg.ToString("X8")

            Case 3  '   64bit
                WdText = reg.ToString("X16")

            Case Else   '   8bit
                WdText = reg.ToString("X2")

        End Select

        Return True

    End Function

    '   USBｲﾍﾞﾝﾄ通知の設定
    Public Function RegisterForDeviceNotifications(ByVal formHandle As IntPtr, ByVal classGuid As Guid, ByRef deviceNotificationHandle As IntPtr) As Boolean

        Dim devBroadcastDeviceInterface As DEV_BROADCAST_DEVICEINTERFACE = New DEV_BROADCAST_DEVICEINTERFACE()
        Dim devBroadcastDeviceInterfaceBuffer As IntPtr
        Dim size As Integer

        Try

            size = Marshal.SizeOf(devBroadcastDeviceInterface)
            devBroadcastDeviceInterface.dbcc_size = size
            devBroadcastDeviceInterface.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE
            devBroadcastDeviceInterface.dbcc_reserved = 0
            devBroadcastDeviceInterface.dbcc_classguid = classGuid
            devBroadcastDeviceInterfaceBuffer = Marshal.AllocHGlobal(size)
            Marshal.StructureToPtr(devBroadcastDeviceInterface, devBroadcastDeviceInterfaceBuffer, True)

            deviceNotificationHandle = RegisterDeviceNotification(formHandle, devBroadcastDeviceInterfaceBuffer, DEVICE_NOTIFY_WINDOW_HANDLE)
            Marshal.PtrToStructure(devBroadcastDeviceInterfaceBuffer, devBroadcastDeviceInterface)
            Marshal.FreeHGlobal(devBroadcastDeviceInterfaceBuffer)

            If (deviceNotificationHandle.ToInt32 = IntPtr.Zero.ToInt32) Then
                Return False
            Else
                Return True
            End If

        Catch ex As Exception
            Throw
        End Try
    End Function

    '   ----------------------------------------------------------------
    '   接続しているSmart-USBﾃﾞﾊﾞｲｽを検索して全てをｵｰﾌﾟﾝする
    '   2013.01.09追加 SUP64.dllのVer1.0.3.0以降で対応
    Public Function OPEN_ALL_DEVICE() As Boolean

        Dim num As UInteger
        Dim i As Integer
        Dim rd As ULong
        Dim adrs As UInteger

        '   ｲﾝﾃﾞｯｸｽﾚｼﾞｽﾀのｱﾄﾞﾚｽを取得
        Try
            adrs = UInteger.Parse(SelForm.TextBox1.Text, Globalization.NumberStyles.Integer)
        Catch ex As Exception
            LOG_PRINT("ｲﾝﾃﾞｯｸｽﾚｼﾞｽﾀのｱﾄﾞﾚｽが不正です。")
            Return False
        End Try


        If (SUP64_Get_Device_Handle(hWinUSBGuid, num, FoundDeviceHandle(0)) = 0) Then

            LOG_PRINT("SUP64_Get_Device_Handle() ERROR!!")
            Return False

        End If

        LOG_PRINT(num & "台のﾎﾞｰﾄﾞが見つかりました")

        '   見つかったﾃﾞﾊﾞｲｽを全てｵｰﾌﾟﾝする
        OpenNum = 0
        For i = 0 To (num - 1)

            '   接続しているﾃﾞﾊﾞｲｽのｵｰﾌﾟﾝ
            If (SUP64_Usb_Open_Handle(FoundDeviceHandle(i), OpenDeviceHandle(i)) = 0) Then

                LOG_PRINT(i & "Device SUP64_Usb_Open_Handle() ERROR!!")
                Return False
            Else
                '   ﾃﾞﾊﾞｲｽのｵｰﾌﾟﾝに成功したのでｲﾝﾃﾞｯｸｽﾚｼﾞｽﾀをﾘｰﾄﾞして内容を表示する。
                If (SUP64_Reg_Read(OpenDeviceHandle(i), adrs, SUP64_RANGE_8BIT, rd) = False) Then
                    LOG_PRINT(i & "Device Read Index Register ERROR!!")
                    SUP64_Usb_Close(OpenDeviceHandle(i))
                    OpenDeviceHandle(i) = INVALID_HANDLE_VALUE
                    Return False
                End If

                '   ｲﾝﾃﾞｸｽﾚｼﾞｽﾀは下位4ﾋﾞｯﾄのみを使用する
                rd = rd And &HFUL
                BoardIndex(i) = rd

                BoardSel(i).ForeColor = Color.Blue
                BoardSel(i).Enabled = True

                '   ﾎﾞｰﾄﾞ名称/ｲﾝﾃﾞｯｸｽ値を表示
                If (SelForm.CheckBox1.Checked = True) Then
                    '   ﾎﾞｰﾄﾞ名称
                    BoardSel(i).Text = "OPEN" + vbCrLf & BoardName(rd)
                Else
                    '   ｲﾝﾃﾞｯｸｽ値
                    BoardSel(i).Text = "OPEN" + vbCrLf & rd.ToString("X2") + "h"
                End If


            End If
        Next

        OpenNum = num
        Return True

    End Function

    '   ----------------------------------------------------------------
    '   ｲﾝﾃﾞｯｸｽﾌｧｲﾙからﾎﾞｰﾄﾞ名称を取得する
    '   ｲﾝﾃﾞｯｸｽﾌｧｲﾙは0～256で記載しているが実際には0～15までしか使用していない
    Public Function GET_BOARD_NAME() As Boolean

        Dim IndexFilePath As String
        Dim line As String
        Dim CommaText() As String
        Dim index As Integer

        Dim i As Integer

        IndexFilePath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location)
        IndexFilePath = IndexFilePath + "\INDEX.csv"

        Try

            Dim IndexFile As New System.IO.StreamReader(IndexFilePath, System.Text.Encoding.Default)

            '   ｲﾝﾃﾞｯｸｽﾌｧｲﾙを1行ﾘｰﾄﾞしてｲﾝﾃﾞｯｸｽとﾎﾞｰﾄﾞ名称に分解する
            While IndexFile.Peek() > -1

                '   先頭から1行読み込む
                line = IndexFile.ReadLine()

                '   空白行ならｽｷｯﾌﾟする
                If (line = "") Then Continue While

                '   ｶﾝﾏﾃﾞﾘﾐﾀで1行を分解する
                '   1項目をｲﾝﾃﾞｯｸｽ(0～255までの整数)
                '   2項目をﾎﾞｰﾄﾞ名称とする
                CommaText = Split(line, ",")

                '   ｲﾝﾃﾞｸｽ(文字列)を数値に変換
                If Integer.TryParse(CommaText(0), index) = True Then

                    BoardName(index) = CommaText(1)

                End If

            End While
            IndexFile.Close()

        Catch ex As Exception

            '   例外処理
            LOG_PRINT("ｲﾝﾃﾞｯｸｽﾌｧｲﾙ(INDEX.csv)が見つかりませんでした。")
            For i = 0 To 255
                BoardName(i) = "unknown"
            Next

            Return False
        End Try

        Return True
    End Function

End Module
