﻿Imports System.Runtime.InteropServices

Module SUP64

    Public Const SUP64_DEVICE_INTERFACE As String = "{82EFB874-53F7-4595-9B80-5388380A1B3A}"
    Public Const APP_NAME As String = "RefApp7 for VB2010"
    Public Const MAX_PATH As Integer = 260


    Public hWinUSBHandle As IntPtr
    Public hWinUSBGuid As New System.Guid(SUP64_DEVICE_INTERFACE)


    Public Const USB_MAX_DEVICE As Integer = 127

    Public Const SUP64_RANGE_8BIT As UInteger = &H0
    Public Const SUP64_RANGE_16BIT As UInteger = &H40
    Public Const SUP64_RANGE_32BIT As UInteger = &H80
    Public Const SUP64_RANGE_64BIT As UInteger = &HC0

    Public Const SUP64_ADRS_MASK As UInteger = &H3F
    Public Const SUP64_RANGE_MASK As UInteger = &HC0

    Public Const SUP64_CONFIG_MODE_ALTERA As Boolean = 0
    Public Const SUP64_CONFIG_MODE_XILINX As Boolean = 1

    Public Const SUP64_BOARDINFO_FIRMID As UShort = &HC0
    Public Const SUP64_BOARDINFO_CHIPVER As UShort = &H80
    Public Const SUP64_BOARDINFO_PID As UShort = &H40
    Public Const SUP64_BOARDINFO_SPEED As UShort = &H0
    Public Const SUP64_FULL_SPEED As UShort = &H0
    Public Const SUP64_HIGH_SPEED As UShort = &H1


    Public Const SUP64_GPIFWAVE_DIR_READ As UShort = &H0
    Public Const SUP64_GPIFWAVE_DIR_WRITE As UShort = &H1
    Public Const SUP64_GPIFWAVE_MODE_BURST As UShort = &H0
    Public Const SUP64_GPIFWAVE_MODE_WORD As UShort = &H1


    Public Const SUP64_GPIO_PORTA As UShort = &H0
    Public Const SUP64_GPIO_PORTC As UShort = &H1
    Public Const SUP64_GPIO_PORTE As UShort = &H2
    Public Const SUP64_GPIO_DIRIN As UShort = &H0
    Public Const SUP64_GPIO_DIROUT As UShort = &H1

    Public Const PID6000 As String = "AX-USB2"
    Public Const PID6400 As String = "SX-USB2"
    Public Const PID7000 As String = "VX-USB2"
    Public Const PID6300 As String = "CX-Card"
    Public Const PID6310 As String = "CX-Card2"
    Public Const PID6311 As String = "CX-USB2"
    Public Const PID6200 As String = "System-SX"
    Public Const PID6401 As String = "System-SX2"
    Public Const PID6500 As String = "USB2.0 I/O Board"
    Public Const PID6501 As String = "USB2.0 I/O Board - FullSpeed"
    Public Const PID6502 As String = "USB2.0 I/O Board - ASAP-XA Option Board"
    Public Const PID6503 As String = "FLASH I/O Board"
    Public Const PID6510 As String = "USB2.0 I/O Board2"
    Public Const PID7200 As String = "SX-Card3"
    Public Const PID7201 As String = "SX-USB3"
    Public Const PID7202 As String = "CX-MCU3"
    Public Const PID7203 As String = "CX-Card4"
    Public Const PID7204 As String = "SX-Card6"

    'Smart-USBPlus APIの定義

    '   --------------------------------------------------------------------------------
    '   USBﾃﾞﾊﾞｲｽのｵｰﾌﾟﾝ/ｸﾛｰｽﾞ関数
    <DllImport("SUP64.dll")>
    Public Function SUP64_Usb_Open(ByVal guidDeviceInterface As System.Guid, ByRef hWinUSBHandle As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Usb_Open2(ByRef hWinUSBHandle As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Usb_Close(ByVal hWinUSBHandle As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Get_Device_Handle(ByVal guidDeviceInterface As System.Guid, ByRef num As UInteger, ByRef FoundHandle As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Usb_Open_Handle(ByVal FoundHandle As IntPtr, ByRef hWinUSBHandle As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Usb_OpenEx(ByVal guidDeviceInterface As System.Guid, ByRef FoundHandle As IntPtr, ByRef hWinUSBHandle As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Usb_CloseEx(ByVal FoundHandle As IntPtr, ByVal hWinUSBHandle As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Find_Device(ByVal guidDeviceInterface As System.Guid, ByVal adrs As UInteger, ByVal id As UInteger, ByRef FoundHandle As IntPtr) As Boolean
    End Function


    '   --------------------------------------------------------------------------------
    '   ﾚｼﾞｽﾀ転送用関数
    <DllImport("SUP64.dll")>
    Public Function SUP64_Reg_Read(ByVal hWinUSBHandle As IntPtr, ByVal adrs As UInteger, ByVal range As UInteger, ByRef rd As ULong) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Reg_Write(ByVal hWinUSBHandle As IntPtr, ByVal adrs As UInteger, ByVal range As UInteger, ByVal wd As ULong) As Boolean
    End Function

    '   --------------------------------------------------------------------------------
    '   ﾒﾓﾘ転送操作用関数
    <DllImport("SUP64.dll")>
    Public Function SUP64_Data_Write(ByVal hWinUSBHandle As IntPtr, ByVal range As Byte, ByVal FileSize As UInteger, ByVal pBuffer As IntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Data_Read(ByVal hWinUSBHandle As IntPtr, ByVal range As Byte, ByVal FileSize As UInteger, ByVal pBuffer As IntPtr) As Boolean
    End Function

    '   --------------------------------------------------------------------------------
    '   各種ﾕｰﾃｨﾘﾃｨ関数
    <DllImport("SUP64.dll")>
    Public Function SUP64_Get_BoardInfo(ByVal hWinUSBHandle As IntPtr, ByVal ByvalSel As UInteger, ByRef ID As UIntPtr) As Boolean
    End Function

    <DllImport("SUP64.dll", CharSet:=CharSet.Unicode)>
    Public Function SUP64_Usb_Config(ByVal hWinUSBHandle As IntPtr, ByVal PathName As String, ByVal Mode As Boolean, ByVal Swap As Boolean, ByVal Encrypt As Boolean) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_I2c_Read(ByVal hWinUSBHandle As IntPtr, ByVal DevAdrs As UInteger, ByVal RegAdrs As UInteger, ByRef Rd As Byte) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_I2c_Write(ByVal hWinUSBHandle As IntPtr, ByVal DevAdrs As UInteger, ByVal RegAdrs As UInteger, ByVal Wd As Byte) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_GPIF_Set_Wave(ByVal hWinUSBHandle As IntPtr, ByVal dir As UShort, ByVal sel As UShort) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Suspend(ByVal hWinUSBHandle As IntPtr, ByVal mode As UShort) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_Get_FPGA_Temp(ByVal hWinUSBHandle As IntPtr, ByVal Sel As UShort, ByRef Temp As UShort) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_GPIO_Dir(ByVal hWinUSBHandle As IntPtr, ByVal port As UShort, ByVal dir As UShort) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_GPIO_Read(ByVal hWinUSBHandle As IntPtr, ByVal port As UShort, ByRef Rd As Byte) As Boolean
    End Function

    <DllImport("SUP64.dll")>
    Public Function SUP64_GPIO_Write(ByVal hWinUSBHandle As IntPtr, ByVal port As UShort, ByVal Wd As UShort) As Boolean
    End Function


End Module
